package org.vtokarev.controller;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.vtokarev.domain.RoomRequest;
import org.vtokarev.domain.RoomRequestStatus;
import org.vtokarev.dto.RoomSearchDto;
import org.vtokarev.service.RoomRequestService;
import org.vtokarev.service.RoomService;
import org.vtokarev.tuples.Pair;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.lang.invoke.MethodHandles;
import java.time.Instant;
import java.util.List;
import java.util.Optional;
import java.util.stream.IntStream;

/**
 * {@code ProceedRequestServlet} class uses for proceeding {@link RoomRequest} that is pay or cancel it.
 * It implements {@code doGet} method that processes GET {@code proceedRequest} requests generated by users with MANAGER role.
 * In the {@code doGet} method, it collects the necessary data from the room request and forwards them to {@code searchRoomManager} view for room searching.
 *
 *  In the {@code doPost} method it implements cancel room request operation. After the operation is completed it forwards the control to {@code requestList}.
 *
 * @author Vyacheslav Tokarev
 */

@WebServlet(urlPatterns = "/proceedRequest", name = "proceedRequestServlet")
public class ProceedRequestServlet extends HttpServlet {

    private final static Logger LOGGER = LogManager.getLogger(MethodHandles.lookup().lookupClass());

    private int recordsPerPage;


    private RoomRequestService roomRequestService;
    private RoomService roomService;

    @Override
    public void init(ServletConfig config) throws ServletException {
        roomRequestService = (RoomRequestService) config.getServletContext().getAttribute("app/RoomRequestService");
        roomService = (RoomService) config.getServletContext().getAttribute("app/RoomService");
        recordsPerPage = (int) config.getServletContext().getAttribute("app/searchRoomManagerRecordsPerPage");
    }

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        try {
            int requestId = Integer.parseInt(req.getParameter("requestId"));
            int userId = Integer.parseInt(req.getParameter("userId"));

            Optional<RoomRequest> roomRequest = roomRequestService.get(requestId);
            roomRequest.ifPresent(rr -> {
                int page = Integer.parseInt(req.getParameter("page"));
                int recordCount = roomService.getBookingRoomsCount(rr.getCheckin(), rr.getCheckout(),
                        true, rr.getRoomClassId(), rr.getPersonsNumber());
                int pageCount = (int) Math.ceil((double) recordCount / recordsPerPage);
                List<Integer> pages = IntStream.range(1, pageCount + 1).boxed().toList();

                Pair<List<RoomSearchDto>, String> rooms = roomService.getRoomsByParams(rr.getCheckin(),
                        rr.getCheckout(), true, rr.getRoomClassId(), rr.getPersonsNumber(),
                        "Price", recordsPerPage, recordsPerPage * (page - 1));

                req.setAttribute("rooms", rooms.getA());
                req.setAttribute("requestId", requestId);
                req.setAttribute("userId", userId);
                req.setAttribute("checkin", rr.getCheckin());
                req.setAttribute("checkout", rr.getCheckout());
                req.setAttribute("page", page);
                req.setAttribute("recordCount", recordCount);
                req.setAttribute("pages", pages);

                if ("empty".equals(rooms.getB())) {
                    req.setAttribute("errorMessage", "no.rooms.matching.search.criteria.message");
                    req.setAttribute("emptyResult", true);
                } else if (!"success".equals(rooms.getB())) {
                    req.setAttribute("errorMessage", rooms.getB());
                }
            });
            req.getRequestDispatcher("/WEB-INF/jsp/searchRoomManager.jsp").forward(req, resp);
        } catch (NumberFormatException e) {
            LOGGER.warn("Failed parse parameters, doGet", e);
            resp.sendRedirect("home");
        }
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws IOException {
        if (req.getParameter("cancel") != null && req.getParameter("requestId") != null) {
            int requestId = Integer.parseInt(req.getParameter("requestId"));
            Optional<RoomRequest> roomRequest = roomRequestService.get(requestId);
            roomRequest.ifPresent(rr -> {
                rr.setStatus(RoomRequestStatus.CANCELLED);
                rr.setRegDate(Instant.now());
                roomRequestService.update(rr);
            });
        }
        resp.sendRedirect("requestList");
    }


}